#!/usr/bin/perl

$datapath = "./spelldata";

@allfiles = ();
opendir THISDIR, $datapath;
@allfiles = sort readdir THISDIR;
closedir THISDIR;

@selections=(
"Quit, writing spellbook",
"Cleric (BFRPG Rules)",
"Magic User (BFRPG Rules)",
"Cleric (Libram Magica)",
"Druid (Libram Magica)",
"Illusionist (Libram Magica)",
"Magic User (Libram Magica)",
"Necromancer (Libram Magica)",
"Bard-Cleric (Supplement)",
"Bard-Druid (Supplement)",
"Bard-Magic User (Supplement)",
"Fey Mage (Supplement)",
"Healer (Supplement)",
"Priest (Supplement)",
"Pyromancer (Supplement)",
"Spellcrafter (Supplement)" );

@fileroots=(
"Nothing",
"BFCleric",
"BFMage",
"LMCleric",
"LMDruid",
"LMIllusionist",
"LMMage",
"LMNecromancer",
"SupBardCleric",
"SupBardDruid",
"SupBardMage",
"SupFeyMage",
"SupHealer",
"SupPriest",
"SupPyromancer",
"SupSpellcrafter" );

printf "\nBase name of the output spell collection? ";
$outbook=<stdin>;
chop($outbook);
$outbook = $outbook."_spellbook.tex";
open OF, ">$outbook";

print OF "\\documentclass[parskip]{scrartcl}\n";
print OF "\\usepackage[margin=15mm]{geometry}\n";
print OF "\\usepackage{tikz}\n";
print OF "\\usepackage{pifont}\n";
print OF "\\usepackage{graphicx}\n";
print OF "\\usepackage{multicol}\n";
print OF "\n";
print OF "\\begin{document}\n";
print OF "\n";
print OF "\n";
print OF "\\pgfmathsetmacro{\\ruleheight}{0.1}\n";
print OF "\\newcommand{\\stripfontsize}{\\Huge}\n";
print OF "\\newcommand{\\captionfontsize}{\\LARGE}\n";
print OF "\\newcommand{\\textfontsize}{\\large}\n";
print OF "\\newcommand{\\tinysize}{\\tiny}\n";
print OF "\n";
print OF "\\begin{multicols}{3}\n";

$adding = 1;
# ACTION LOOP GOES HERE
while ($adding) {
  print "\n-----Spellbook Source-----\n";
  for ($i = 0; $i <= $#selections; $i++) {
    print "[$i] $selections[$i]\n";
  }
  print "--------------------------\n\nChoose: ";
  $ans = <stdin>;
  chop($ans);
  @files = (); $n=0;
  if ($ans == 0) {$adding = 0;}
  elsif ($ans > 0 && $ans <= $#selections) {
    print "\nLevel: ";
    $ans2 = <stdin>;
    chop($ans2);
    $fileroot = "$fileroots[$ans]-$ans2";
    for ($k = 0; $k <= $#allfiles; $k++) {

      if (index($allfiles[$k],"$fileroot") != -1) {
        $files[$n]=$allfiles[$k];
        $n++;
      }
    }
    print "\n-----Available Spells-----\n";
    for ($j = 0; $j < $n; $j++) {
      print "[$j] $files[$j]\n";
    }
    print "--------------------------\n\nSpell:";
    $ans3=<stdin>;
    chop($ans3);

    if ($ans3 >=0 && $ans3 <$n){
      $myfile = $datapath."/$files[$ans3]";
      print "Adding: $myfile\n";

      open IF, $myfile;
      while ($line=<IF>){
        print OF $line;
      }
      close IF;

    }
    else {
      print "\nNot a valid spell.  Try again.\n\n";
    }
    

  }
  else {
    print "Did not understand the entry.  Try again.\n\n";
  }
}

# NOW FINISH
print OF "\\end{multicols}\n";
print OF "\\end{document}\n";
close OF;

